/* -----------------------------------------------------------------------------
 *
 * Copyright (c) 2014-2019 Alexis Naveros.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event will the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 * claim that you wrote the original software. If you use this software
 * in a product, an acknowledgment in the product documentation would be
 * appreciated but is not required.
 * 2. Altered source versions must be plainly marked as such, and must not be
 * misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 *
 * -----------------------------------------------------------------------------
 */

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdint.h>


////



#define BS_COLOR_INDEX_RANGE (256)

int bsColorTranslationBo2Bl[BS_COLOR_INDEX_RANGE] = {0, -1, 21, 23, 24, 26, 28, 31, 32, 33, 37, 38, 40, 41, 42, 43, 44, 47, 48, 49, 80, 81, 102, 106, 111, 113, 114, 119, 124, 126, 135, 138, 140, 141, 143, 151, 154, -1, 11, 7, 97, 36, 105, 110, 103, 104, 8, 153, 63, 109, 85, 120, 91, 10, 68, 89, 59, 69, 39, 29, 160, 6, 152, 62, 86, 90, 9, 35, 56, 93, 34, 72, 71, 156, 150, 94, 157, 76, 73, 155, 4, 5, 88, 27, 25, 55, 54, 58, 87, 2, 99, 96, 1, 3, 158, 13, 108, 12, 14, 50, 20, 15, 74, 16, 121, 98, 107, 51, 17, 19, 57, 122, 52, 64, 82, 22, 84, 95, 78, 77, 115, 61, 66, 83, 65, 70, 67, 46, 118, 159, 60, 101, 100, 116, 117, 142, 128, 132, 133, 149, 139, 125, 136, 137, 144, 145, 148, 130, 129, 146, 134, 131, 127, 147, 123, -1, -1, -1, -1, -1, -1, 18, -1, -1, -1, 162, -1, 163, -1, 161, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};

int bsColorTranslationBl2Bo[BS_COLOR_INDEX_RANGE] = {0, 92, 89, 93, 80, 81, 61, 39, 46, 66, 53, 38, 97, 95, 98, 101, 103, 108, 161, 109, 100, 2, 115, 3, 4, 84, 5, 83, 6, 59, -1, 7, 8, 9, 70, 67, 41, 10, 11, 58, 12, 13, 14, 15, 16, -1, 127, 17, 18, 19, 99, 107, 112, -1, 86, 85, 68, 110, 87, 56, 130, 121, 63, 48, 113, 124, 122, 126, 54, 57, 125, 72, 71, 78, 102, -1, 77, 119, 118, -1, 20, 21, 114, 123, 116, 50, 64, 88, 82, 55, 65, 52, -1, 69, 75, 117, 91, 40, 105, 90, 132, 131, 22, 44, 45, 42, 23, 106, 96, 49, 43, 24, -1, 25, 26, 120, 133, 134, 128, 27, 51, 104, 111, 154, 28, 141, 29, 152, 136, 148, 147, 151, 137, 138, 150, 30, 142, 143, 31, 140, 32, 33, 135, 34, 144, 145, 149, 153, 146, 139, 74, 35, 62, 47, 36, 79, 73, 76, 94, 129, 60, 169, 165, 167, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1};



////


#if 0

#include <string.h>
#include <math.h>
#include <limits.h>
#include <float.h>

#include <stdarg.h>

#include "cc.h"
#include "ccstr.h"
#include "mm.h"

#include "bsx.h"

#include "iolog.h"
#include "json.h"
#include "bsorder.h"
#include "brickowl.h"

/*
gcc colortable.c iolog.c cc.c brickowl.c json.c debugtrack.c bsorder.c -s -o colortable -lpthread
*/

int main()
{
  int index;
  char *bar = "{\"0\":{\"id\":\"0\",\"name\":\"Not Applicable\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"0\"],\"bl_names\":[\"N\\/A\"],\"lego_colors\":[]},\"2\":{\"id\":\"2\",\"name\":\"Chrome Gold\",\"hex\":\"f1f2e1\",\"peeron_names\":[\"ChromeGold\"],\"ldraw_ids\":[\"334\"],\"bl_ids\":[\"21\"],\"bl_names\":[\"Chrome Gold\"],\"lego_colors\":[]},\"3\":{\"id\":\"3\",\"name\":\"Pink\",\"hex\":\"FFC0CB\",\"peeron_names\":[\"Pink\"],\"ldraw_ids\":[\"13\"],\"bl_ids\":[\"23\"],\"bl_names\":[\"Pink\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"LIGHT REDDISH VIOLET\"},{\"lego_id\":\"9\",\"raw_name\":\"PINK\"}]},\"4\":{\"id\":\"4\",\"name\":\"Purple\",\"hex\":\"a5499c\",\"peeron_names\":[\"Purple\"],\"ldraw_ids\":[\"22\"],\"bl_ids\":[\"24\"],\"bl_names\":[\"Purple\"],\"lego_colors\":[{\"lego_id\":\"104\",\"raw_name\":\"BRIGHT VIOLET\"}]},\"5\":{\"id\":\"5\",\"name\":\"Light Salmon\",\"hex\":\"FFDEDC\",\"peeron_names\":[\"LtSalmon\"],\"ldraw_ids\":[\"100\"],\"bl_ids\":[\"26\"],\"bl_names\":[\"Light Salmon\"],\"lego_colors\":[{\"lego_id\":\"100\",\"raw_name\":\"LIGHT RED\"}]},\"6\":{\"id\":\"6\",\"name\":\"Flesh\",\"hex\":\"CC8062\",\"peeron_names\":[\"Flesh\"],\"ldraw_ids\":[\"92\"],\"bl_ids\":[\"28\"],\"bl_names\":[\"Flesh\"],\"lego_colors\":[{\"lego_id\":\"18\",\"raw_name\":\"NOUGAT\"}]},\"7\":{\"id\":\"7\",\"name\":\"Medium Orange\",\"hex\":\"FFA531\",\"peeron_names\":[\"MdOrange\"],\"ldraw_ids\":[\"462\"],\"bl_ids\":[\"31\"],\"bl_names\":[\"Medium Orange\"],\"lego_colors\":[{\"lego_id\":\"105\",\"raw_name\":\"BRIGHT YELLOWISH ORANGE\"}]},\"8\":{\"id\":\"8\",\"name\":\"Light Orange\",\"hex\":\"f7ad63\",\"peeron_names\":[\"LtOrange\"],\"ldraw_ids\":[\"125\"],\"bl_ids\":[\"32\"],\"bl_names\":[\"Light Orange\"],\"lego_colors\":[{\"lego_id\":\"125\",\"raw_name\":\"LIGHT ORANGE\"}]},\"9\":{\"id\":\"9\",\"name\":\"Light Yellow\",\"hex\":\"ffe383\",\"peeron_names\":[\"LtYellow\"],\"ldraw_ids\":[\"18\"],\"bl_ids\":[\"33\"],\"bl_names\":[\"Light Yellow\"],\"lego_colors\":[{\"lego_id\":\"3\",\"raw_name\":\"LIGHT YELLOW\"}]},\"10\":{\"id\":\"10\",\"name\":\"Medium Green\",\"hex\":\"62F58E\",\"peeron_names\":[\"MdGreen\"],\"ldraw_ids\":[\"74\"],\"bl_ids\":[\"37\"],\"bl_names\":[\"Medium Green\"],\"lego_colors\":[{\"lego_id\":\"29\",\"raw_name\":\"MEDIUM GREEN\"}]},\"11\":{\"id\":\"11\",\"name\":\"Light Green\",\"hex\":\"a5dbb5\",\"peeron_names\":[\"LtGreen\"],\"ldraw_ids\":[\"17\"],\"bl_ids\":[\"38\"],\"bl_names\":[\"Light Green\"],\"lego_colors\":[{\"lego_id\":\"6\",\"raw_name\":\"LIGHT GREEN\"}]},\"12\":{\"id\":\"12\",\"name\":\"Light Turquoise\",\"hex\":\"31B5CA\",\"peeron_names\":[\"LtTeal\"],\"ldraw_ids\":[\"11\"],\"bl_ids\":[\"40\"],\"bl_names\":[\"Light Turquoise\"],\"lego_colors\":[{\"lego_id\":\"116\",\"raw_name\":\"MEDIUM BLUISH GREEN\"}]},\"13\":{\"id\":\"13\",\"name\":\"Aqua\",\"hex\":\"b5d3d6\",\"peeron_names\":[\"Aqua\"],\"ldraw_ids\":[\"118\"],\"bl_ids\":[\"41\"],\"bl_names\":[\"Aqua\"],\"lego_colors\":[{\"lego_id\":\"118\",\"raw_name\":\"LIGHT BLUISH GREEN\"}]},\"14\":{\"id\":\"14\",\"name\":\"Medium Blue\",\"hex\":\"61afff\",\"peeron_names\":[\"MdBlue\"],\"ldraw_ids\":[\"73\"],\"bl_ids\":[\"42\"],\"bl_names\":[\"Medium Blue\"],\"lego_colors\":[{\"lego_id\":\"102\",\"raw_name\":\"MD.BLUE\"},{\"lego_id\":\"102\",\"raw_name\":\"MEDIUM BLUE\"}]},\"15\":{\"id\":\"15\",\"name\":\"Violet\",\"hex\":\"3448a4\",\"peeron_names\":[\"Violet\"],\"ldraw_ids\":[\"110\"],\"bl_ids\":[\"43\"],\"bl_names\":[\"Violet\"],\"lego_colors\":[{\"lego_id\":\"110\",\"raw_name\":\"BRIGHT BLUISH VIOLET\"}]},\"16\":{\"id\":\"16\",\"name\":\"Light Violet\",\"hex\":\"C9CAE2\",\"peeron_names\":[\"LtViolet\"],\"ldraw_ids\":[\"20\"],\"bl_ids\":[\"44\"],\"bl_names\":[\"Light Violet\"],\"lego_colors\":[{\"lego_id\":\"39\",\"raw_name\":\"LIGHT BLUISH VIOLET\"}]},\"17\":{\"id\":\"17\",\"name\":\"Dark Pink\",\"hex\":\"C87080\",\"peeron_names\":[\"DkPink\"],\"ldraw_ids\":[\"5\"],\"bl_ids\":[\"47\"],\"bl_names\":[\"Dark Pink\"],\"lego_colors\":[{\"lego_id\":\"221\",\"raw_name\":\"BR. PURPLE\"},{\"lego_id\":\"221\",\"raw_name\":\"BRIGHT PURPLE\"}]},\"18\":{\"id\":\"18\",\"name\":\"Sand Green\",\"hex\":\"76a290\",\"peeron_names\":[\"SandGreen\"],\"ldraw_ids\":[\"378\"],\"bl_ids\":[\"48\"],\"bl_names\":[\"Sand Green\"],\"lego_colors\":[{\"lego_id\":\"151\",\"raw_name\":\"SAND GREEN\"}]},\"19\":{\"id\":\"19\",\"name\":\"Very Light Gray\",\"hex\":\"E8E8E8\",\"peeron_names\":[\"ScalaGray\"],\"ldraw_ids\":[\"503\"],\"bl_ids\":[\"49\"],\"bl_names\":[\"Very Light Gray\"],\"lego_colors\":[{\"lego_id\":\"103\",\"raw_name\":\"LIGHT GREY\"}]},\"20\":{\"id\":\"20\",\"name\":\"Dark Green\",\"hex\":\"2E5543\",\"peeron_names\":[\"DkGreen\"],\"ldraw_ids\":[\"288\"],\"bl_ids\":[\"80\"],\"bl_names\":[\"Dark Green\"],\"lego_colors\":[{\"lego_id\":\"141\",\"raw_name\":\"EARTH GREEN\"}]},\"21\":{\"id\":\"21\",\"name\":\"Flat Dark Gold\",\"hex\":\"AD7118\",\"peeron_names\":[\"PearlDkGold\"],\"ldraw_ids\":[\"178\"],\"bl_ids\":[\"81\"],\"bl_names\":[\"Flat Dark Gold\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"METALLIC SAND YELLOW\"},{\"lego_id\":\"187\",\"raw_name\":\"SAND YELLOW METALLIC\"}]},\"22\":{\"id\":\"22\",\"name\":\"Transparent Purple Glitter\",\"hex\":\"3A2B82\",\"peeron_names\":[\"TrPurpleGlitter\"],\"ldraw_ids\":[\"129\"],\"bl_ids\":[\"102\"],\"bl_names\":[\"Glitter Trans-Purple\"],\"lego_colors\":[{\"lego_id\":\"129\",\"raw_name\":\"TR.BR. BLUISH.VIOL.W.GLITER2%\"},{\"lego_id\":\"129\",\"raw_name\":\"TR.BR.BL.V.G\"}]},\"23\":{\"id\":\"23\",\"name\":\"Fabuland Brown\",\"hex\":\"B3694E\",\"peeron_names\":[\"FabuBrown\"],\"ldraw_ids\":[\"450\"],\"bl_ids\":[\"106\"],\"bl_names\":[\"Fabuland Brown\"],\"lego_colors\":[]},\"24\":{\"id\":\"24\",\"name\":\"Speckle Black\",\"hex\":\"7C7E7C\",\"peeron_names\":[\"BlackGlitter\"],\"ldraw_ids\":[\"132\"],\"bl_ids\":[\"111\"],\"bl_names\":[\"Speckle Black-Silver\"],\"lego_colors\":[{\"lego_id\":\"132\",\"raw_name\":\"BLACK WITH GLITTER\"},{\"lego_id\":null,\"raw_name\":\"COOL SILVER, DIFFUSE\"}]},\"25\":{\"id\":\"25\",\"name\":\"Transparent Very Light Blue\",\"hex\":\"B7C8BF\",\"peeron_names\":[\"TrIceBlue\"],\"ldraw_ids\":[\"43\"],\"bl_ids\":[\"113\"],\"bl_names\":[\"Trans-Very Lt Blue\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. LIGHT BLUISH GREEN\"}]},\"26\":{\"id\":\"26\",\"name\":\"Transparent Light Purple\",\"hex\":\"B97AB1\",\"peeron_names\":[\"TrLilac\"],\"ldraw_ids\":[\"236\"],\"bl_ids\":[\"114\"],\"bl_names\":[\"Trans-Light Purple\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. REDDISH LILAC\"}]},\"27\":{\"id\":\"27\",\"name\":\"Pearl Very Light Gray\",\"hex\":\"D4D2CD\",\"peeron_names\":[\"PearlVLGray\"],\"ldraw_ids\":[\"150\"],\"bl_ids\":[\"119\"],\"bl_names\":[\"Pearl Very Light Gray\"],\"lego_colors\":[]},\"28\":{\"id\":\"28\",\"name\":\"Modulex Medium Stone Gray\",\"hex\":\"AfB5C7\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"124\"],\"bl_names\":[\"Mx Light Bluish Gray\"],\"lego_colors\":[]},\"29\":{\"id\":\"29\",\"name\":\"Modulex Charcoal Gray\",\"hex\":\"595D60\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"126\"],\"bl_names\":[\"Mx Charcoal Gray\"],\"lego_colors\":[]},\"30\":{\"id\":\"30\",\"name\":\"Modulex Orange\",\"hex\":\"F47B30\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"135\"],\"bl_names\":[\"Mx Orange\"],\"lego_colors\":[]},\"31\":{\"id\":\"31\",\"name\":\"Modulex Ochre Yellow\",\"hex\":\"FED557\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"138\"],\"bl_names\":[\"Mx Ochre Yellow\"],\"lego_colors\":[]},\"32\":{\"id\":\"32\",\"name\":\"Modulex Olive Green\",\"hex\":\"7C9051\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"140\"],\"bl_names\":[\"Mx Olive Green\"],\"lego_colors\":[]},\"33\":{\"id\":\"33\",\"name\":\"Modulex Pastel Green\",\"hex\":\"7DB538\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"141\"],\"bl_names\":[\"Mx Pastel Green\"],\"lego_colors\":[]},\"34\":{\"id\":\"34\",\"name\":\"Modulex Tile Blue\",\"hex\":\"0057A6\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"143\"],\"bl_names\":[\"Mx Tile Blue\"],\"lego_colors\":[]},\"35\":{\"id\":\"35\",\"name\":\"Speckle Black Gold\",\"hex\":\"AB9421\",\"peeron_names\":[\"BlackGoldGlitter\"],\"ldraw_ids\":[null],\"bl_ids\":[\"151\"],\"bl_names\":[\"Speckle Black-Gold\"],\"lego_colors\":[]},\"36\":{\"id\":\"36\",\"name\":\"Lavender\",\"hex\":\"CBA2C8\",\"peeron_names\":[\"Lavender\"],\"ldraw_ids\":[null],\"bl_ids\":[\"154\"],\"bl_names\":[\"Lavender\"],\"lego_colors\":[{\"lego_id\":\"325\",\"raw_name\":\"LAVENDER\"}]},\"38\":{\"id\":\"38\",\"name\":\"Black\",\"hex\":\"212121\",\"peeron_names\":[\"Black\"],\"ldraw_ids\":[\"0\"],\"bl_ids\":[\"11\"],\"bl_names\":[\"Black\"],\"lego_colors\":[{\"lego_id\":\"26\",\"raw_name\":\"BLACK\"},{\"lego_id\":null,\"raw_name\":\"CONDUCT. BLACK\"}]},\"39\":{\"id\":\"39\",\"name\":\"Blue\",\"hex\":\"0057a6\",\"peeron_names\":[\"Blue\"],\"ldraw_ids\":[\"1\"],\"bl_ids\":[\"7\"],\"bl_names\":[\"Blue\"],\"lego_colors\":[{\"lego_id\":\"23\",\"raw_name\":\"BR. BLUE\"},{\"lego_id\":\"23\",\"raw_name\":\"BR.BLUE\"},{\"lego_id\":\"23\",\"raw_name\":\"BRIGHT BLUE\"}]},\"40\":{\"id\":\"40\",\"name\":\"Royal Blue\",\"hex\":\"506cef\",\"peeron_names\":[\"RoyalBlue\"],\"ldraw_ids\":[\"112\"],\"bl_ids\":[\"97\"],\"bl_names\":[\"Blue-Violet\"],\"lego_colors\":[{\"lego_id\":\"112\",\"raw_name\":\"ROYAL BLUE\"}]},\"41\":{\"id\":\"41\",\"name\":\"Bright Green\",\"hex\":\"10cb31\",\"peeron_names\":[\"BtGreen\"],\"ldraw_ids\":[\"10\"],\"bl_ids\":[\"36\"],\"bl_names\":[\"Bright Green\"],\"lego_colors\":[{\"lego_id\":\"37\",\"raw_name\":\"BR.GREEN\"},{\"lego_id\":\"37\",\"raw_name\":\"BRIGHT GREEN\"}]},\"42\":{\"id\":\"42\",\"name\":\"Bright Light Blue\",\"hex\":\"9FC3E9\",\"peeron_names\":[\"LtRoyalBlue\"],\"ldraw_ids\":[\"212\"],\"bl_ids\":[\"105\"],\"bl_names\":[\"Bright Light Blue\"],\"lego_colors\":[{\"lego_id\":\"212\",\"raw_name\":\"LGH. ROY. BLUE\"},{\"lego_id\":\"212\",\"raw_name\":\"LIGHT ROYAL BLUE\"}]},\"43\":{\"id\":\"43\",\"name\":\"Bright Light Orange\",\"hex\":\"F7BA30\",\"peeron_names\":[\"BtLtOrange\"],\"ldraw_ids\":[\"191\"],\"bl_ids\":[\"110\"],\"bl_names\":[\"Bright Light Orange\"],\"lego_colors\":[{\"lego_id\":\"191\",\"raw_name\":\"FL. YELL-ORA\"},{\"lego_id\":\"191\",\"raw_name\":\"FLAME YELLOWISH ORANGE\"}]},\"44\":{\"id\":\"44\",\"name\":\"Bright Light Yellow\",\"hex\":\"F3E055\",\"peeron_names\":[\"CoolYellow\"],\"ldraw_ids\":[\"226\"],\"bl_ids\":[\"103\"],\"bl_names\":[\"Bright Light Yellow\"],\"lego_colors\":[{\"lego_id\":\"226\",\"raw_name\":\"COOL YEL.\"},{\"lego_id\":\"226\",\"raw_name\":\"COOL YELLOW\"}]},\"45\":{\"id\":\"45\",\"name\":\"Bright Pink\",\"hex\":\"FFBBFF\",\"peeron_names\":[\"LtPurple\"],\"ldraw_ids\":[\"29\"],\"bl_ids\":[\"104\"],\"bl_names\":[\"Bright Pink\"],\"lego_colors\":[{\"lego_id\":\"222\",\"raw_name\":\"LGH. PURPLE\"},{\"lego_id\":\"222\",\"raw_name\":\"LIGHT PURPLE\"}]},\"46\":{\"id\":\"46\",\"name\":\"Brown\",\"hex\":\"532115\",\"peeron_names\":[\"OldBrown\"],\"ldraw_ids\":[\"6\"],\"bl_ids\":[\"8\"],\"bl_names\":[\"Brown\"],\"lego_colors\":[{\"lego_id\":\"25\",\"raw_name\":\"EARTH ORANGE\"}]},\"47\":{\"id\":\"47\",\"name\":\"Dark Azure\",\"hex\":\"3399FF\",\"peeron_names\":[\"DkAzure\"],\"ldraw_ids\":[\"321\"],\"bl_ids\":[\"153\"],\"bl_names\":[\"Dark Azure\"],\"lego_colors\":[{\"lego_id\":\"321\",\"raw_name\":\"DARK AZUR\"}]},\"48\":{\"id\":\"48\",\"name\":\"Dark Blue\",\"hex\":\"143044\",\"peeron_names\":[\"NavyBlue\"],\"ldraw_ids\":[\"272\"],\"bl_ids\":[\"63\"],\"bl_names\":[\"Dark Blue\"],\"lego_colors\":[{\"lego_id\":\"140\",\"raw_name\":\"EARTH BLUE\"}]},\"49\":{\"id\":\"49\",\"name\":\"Dark Royal Blue\",\"hex\":\"2032B0\",\"peeron_names\":[\"DkRoyalBlue\"],\"ldraw_ids\":[\"23\"],\"bl_ids\":[\"109\"],\"bl_names\":[\"Dark Blue-Violet\"],\"lego_colors\":[{\"lego_id\":\"196\",\"raw_name\":\"DARK ROYAL BLUE\"}]},\"50\":{\"id\":\"50\",\"name\":\"Dark Stone Gray\",\"hex\":\"595D60\",\"peeron_names\":[\"DkStone\"],\"ldraw_ids\":[\"72\"],\"bl_ids\":[\"85\"],\"bl_names\":[\"Dark Bluish Gray\"],\"lego_colors\":[{\"lego_id\":\"199\",\"raw_name\":\"DARK STONE GREY\"},{\"lego_id\":\"199\",\"raw_name\":\"DK. ST. GREY\"}]},\"51\":{\"id\":\"51\",\"name\":\"Dark Brown\",\"hex\":\"330000\",\"peeron_names\":[\"DkBrown\"],\"ldraw_ids\":[\"308\"],\"bl_ids\":[\"120\"],\"bl_names\":[\"Dark Brown\"],\"lego_colors\":[{\"lego_id\":\"308\",\"raw_name\":\"DARK BROWN\"},{\"lego_id\":\"308\",\"raw_name\":\"DK. BROWN\"}]},\"52\":{\"id\":\"52\",\"name\":\"Dark Flesh\",\"hex\":\"774125\",\"peeron_names\":[\"DkFlesh\"],\"ldraw_ids\":[\"86\"],\"bl_ids\":[\"91\"],\"bl_names\":[\"Dark Flesh\"],\"lego_colors\":[{\"lego_id\":\"217\",\"raw_name\":\"BROWN\"}]},\"53\":{\"id\":\"53\",\"name\":\"Dark Gray\",\"hex\":\"6b5a5a\",\"peeron_names\":[\"OldDkGray\"],\"ldraw_ids\":[\"8\"],\"bl_ids\":[\"10\"],\"bl_names\":[\"Dark Gray\"],\"lego_colors\":[{\"lego_id\":\"27\",\"raw_name\":\"DARK GREY\"}]},\"54\":{\"id\":\"54\",\"name\":\"Dark Orange\",\"hex\":\"b35408\",\"peeron_names\":[\"DkOrange\"],\"ldraw_ids\":[\"484\"],\"bl_ids\":[\"68\"],\"bl_names\":[\"Dark Orange\"],\"lego_colors\":[{\"lego_id\":\"38\",\"raw_name\":\"DARK ORANGE\"},{\"lego_id\":\"38\",\"raw_name\":\"DK.ORA\"}]},\"55\":{\"id\":\"55\",\"name\":\"Dark Purple\",\"hex\":\"5f2683\",\"peeron_names\":[\"MdLilac\"],\"ldraw_ids\":[\"85\"],\"bl_ids\":[\"89\"],\"bl_names\":[\"Dark Purple\"],\"lego_colors\":[{\"lego_id\":\"268\",\"raw_name\":\"M. LILAC\"},{\"lego_id\":\"268\",\"raw_name\":\"MEDIUM LILAC\"}]},\"56\":{\"id\":\"56\",\"name\":\"Dark Red\",\"hex\":\"6a0e15\",\"peeron_names\":[\"DkRed\"],\"ldraw_ids\":[\"320\"],\"bl_ids\":[\"59\"],\"bl_names\":[\"Dark Red\"],\"lego_colors\":[{\"lego_id\":\"154\",\"raw_name\":\"DARK RED\"},{\"lego_id\":\"154\",\"raw_name\":\"NEW DARK RED\"}]},\"57\":{\"id\":\"57\",\"name\":\"Dark Tan\",\"hex\":\"907450\",\"peeron_names\":[\"DkTan\"],\"ldraw_ids\":[\"28\"],\"bl_ids\":[\"69\"],\"bl_names\":[\"Dark Tan\"],\"lego_colors\":[{\"lego_id\":\"138\",\"raw_name\":\"SAND YELLOW\"}]},\"58\":{\"id\":\"58\",\"name\":\"Dark Turquoise\",\"hex\":\"008a80\",\"peeron_names\":[\"Teal\"],\"ldraw_ids\":[\"3\"],\"bl_ids\":[\"39\"],\"bl_names\":[\"Dark Turquoise\"],\"lego_colors\":[{\"lego_id\":\"107\",\"raw_name\":\"BRIGHT BLUISH GREEN\"}]},\"59\":{\"id\":\"59\",\"name\":\"Earth Orange\",\"hex\":\"E6881D\",\"peeron_names\":[\"EarthOrange\"],\"ldraw_ids\":[\"366\"],\"bl_ids\":[\"29\"],\"bl_names\":[\"Earth Orange\"],\"lego_colors\":[{\"lego_id\":\"12\",\"raw_name\":\"LIGHT ORANGE BROWN\"}]},\"60\":{\"id\":\"60\",\"name\":\"Fabuland Orange\",\"hex\":\"EF9121\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"160\"],\"bl_names\":[\"Fabuland Orange\"],\"lego_colors\":[]},\"61\":{\"id\":\"61\",\"name\":\"Green\",\"hex\":\"00642e\",\"peeron_names\":[\"Green\"],\"ldraw_ids\":[\"2\"],\"bl_ids\":[\"6\"],\"bl_names\":[\"Green\"],\"lego_colors\":[{\"lego_id\":\"28\",\"raw_name\":\"DARK GREEN\"},{\"lego_id\":\"28\",\"raw_name\":\"DK.GREEN\"}]},\"62\":{\"id\":\"62\",\"name\":\"Light Aqua\",\"hex\":\"CCFFFF\",\"peeron_names\":[\"LtAqua\"],\"ldraw_ids\":[\"323\"],\"bl_ids\":[\"152\"],\"bl_names\":[\"Light Aqua\"],\"lego_colors\":[{\"lego_id\":\"323\",\"raw_name\":\"AQUA\"}]},\"63\":{\"id\":\"63\",\"name\":\"Light Blue\",\"hex\":\"B4D2E3\",\"peeron_names\":[\"LtBlue\"],\"ldraw_ids\":[\"9\"],\"bl_ids\":[\"62\"],\"bl_names\":[\"Light Blue\"],\"lego_colors\":[{\"lego_id\":\"45\",\"raw_name\":\"LIGHT BLUE\"}]},\"64\":{\"id\":\"64\",\"name\":\"Medium Stone Gray\",\"hex\":\"afb5c7\",\"peeron_names\":[\"MdStone\"],\"ldraw_ids\":[\"71\"],\"bl_ids\":[\"86\"],\"bl_names\":[\"Light Bluish Gray\"],\"lego_colors\":[{\"lego_id\":\"194\",\"raw_name\":\"MED. ST-GREY\"},{\"lego_id\":\"194\",\"raw_name\":\"MEDIUM STONE GREY\"}]},\"65\":{\"id\":\"65\",\"name\":\"Light Flesh\",\"hex\":\"feccb0\",\"peeron_names\":[\"LtFlesh\"],\"ldraw_ids\":[\"78\"],\"bl_ids\":[\"90\"],\"bl_names\":[\"Light Flesh\"],\"lego_colors\":[{\"lego_id\":\"263\",\"raw_name\":\"L.NOUGAT\"},{\"lego_id\":\"263\",\"raw_name\":\"LIGHT NOUGAT\"}]},\"66\":{\"id\":\"66\",\"name\":\"Light Gray\",\"hex\":\"9c9c9c\",\"peeron_names\":[\"OldGray\"],\"ldraw_ids\":[\"7\"],\"bl_ids\":[\"9\"],\"bl_names\":[\"Light Gray\"],\"lego_colors\":[{\"lego_id\":\"2\",\"raw_name\":\"GREY\"}]},\"67\":{\"id\":\"67\",\"name\":\"Light Lime\",\"hex\":\"EbEE8F\",\"peeron_names\":[\"LtLime\"],\"ldraw_ids\":[\"120\"],\"bl_ids\":[\"35\"],\"bl_names\":[\"Light Lime\"],\"lego_colors\":[{\"lego_id\":\"120\",\"raw_name\":\"LIGHT YELLOWISH GREEN\"}]},\"68\":{\"id\":\"68\",\"name\":\"Light Pink\",\"hex\":\"FFE1FF\",\"peeron_names\":[\"ParaPink\"],\"ldraw_ids\":[\"77\"],\"bl_ids\":[\"56\"],\"bl_names\":[\"Light Pink\"],\"lego_colors\":[]},\"69\":{\"id\":\"69\",\"name\":\"Light Purple\",\"hex\":\"DA70D6\",\"peeron_names\":[\"BtPurple\"],\"ldraw_ids\":[\"69\"],\"bl_ids\":[\"93\"],\"bl_names\":[\"Light Purple\"],\"lego_colors\":[{\"lego_id\":\"198\",\"raw_name\":\"BRIGHT REDDISH LILAC\"}]},\"70\":{\"id\":\"70\",\"name\":\"Lime\",\"hex\":\"A6CA55\",\"peeron_names\":[\"Lime\"],\"ldraw_ids\":[\"27\"],\"bl_ids\":[\"34\"],\"bl_names\":[\"Lime\"],\"lego_colors\":[{\"lego_id\":\"119\",\"raw_name\":\"BR.YEL-GREEN\"},{\"lego_id\":\"119\",\"raw_name\":\"BRIGHT YELLOWISH GREEN\"}]},\"71\":{\"id\":\"71\",\"name\":\"Maersk Blue\",\"hex\":\"6BADD6\",\"peeron_names\":[\"MaerskBlue\"],\"ldraw_ids\":[\"313\"],\"bl_ids\":[\"72\"],\"bl_names\":[\"Maersk Blue\"],\"lego_colors\":[{\"lego_id\":\"11\",\"raw_name\":\"PASTEL BLUE\"}]},\"72\":{\"id\":\"72\",\"name\":\"Magenta\",\"hex\":\"B52952\",\"peeron_names\":[\"Magenta\"],\"ldraw_ids\":[\"26\"],\"bl_ids\":[\"71\"],\"bl_names\":[\"Magenta\"],\"lego_colors\":[{\"lego_id\":\"124\",\"raw_name\":\"BR.RED-VIOL.\"},{\"lego_id\":\"124\",\"raw_name\":\"BRIGHT REDDISH VIOLET\"}]},\"73\":{\"id\":\"73\",\"name\":\"Medium Azure\",\"hex\":\"42C0FB\",\"peeron_names\":[\"MdAzure\"],\"ldraw_ids\":[null],\"bl_ids\":[\"156\"],\"bl_names\":[\"Medium Azure\"],\"lego_colors\":[{\"lego_id\":\"322\",\"raw_name\":\"MEDIUM AZUR\"}]},\"74\":{\"id\":\"74\",\"name\":\"Medium Dark Flesh\",\"hex\":\"E78B3E\",\"peeron_names\":[\"MkDkFlesh\"],\"ldraw_ids\":[\"84\"],\"bl_ids\":[\"150\"],\"bl_names\":[\"Medium Dark Flesh\"],\"lego_colors\":[{\"lego_id\":\"312\",\"raw_name\":\"M. NOUGAT\"},{\"lego_id\":\"312\",\"raw_name\":\"MEDIUM NOUGAT\"}]},\"75\":{\"id\":\"75\",\"name\":\"Medium Dark Pink\",\"hex\":\"F785B1\",\"peeron_names\":[\"DuploRose\"],\"ldraw_ids\":[\"351\"],\"bl_ids\":[\"94\"],\"bl_names\":[\"Medium Dark Pink\"],\"lego_colors\":[{\"lego_id\":\"22\",\"raw_name\":\"MEDIUM REDDISH VIOLET\"}]},\"76\":{\"id\":\"76\",\"name\":\"Medium Lavender\",\"hex\":\"B5A5D5\",\"peeron_names\":[\"MdLavender\"],\"ldraw_ids\":[null],\"bl_ids\":[\"157\"],\"bl_names\":[\"Medium Lavender\"],\"lego_colors\":[{\"lego_id\":\"324\",\"raw_name\":\"MEDIUM LAVENDEL\"},{\"lego_id\":\"324\",\"raw_name\":\"MEDIUM LAVENDER\"}]},\"77\":{\"id\":\"77\",\"name\":\"Medium Lime\",\"hex\":\"BDC618\",\"peeron_names\":[\"MdLime\"],\"ldraw_ids\":[null],\"bl_ids\":[\"76\"],\"bl_names\":[\"Medium Lime\"],\"lego_colors\":[{\"lego_id\":\"115\",\"raw_name\":\"MEDIUM YELLOWISH GREEN\"}]},\"78\":{\"id\":\"78\",\"name\":\"Medium Violet\",\"hex\":\"9391e4\",\"peeron_names\":[\"MdViolet\"],\"ldraw_ids\":[null],\"bl_ids\":[\"73\"],\"bl_names\":[\"Medium Violet\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"MEDIUM BLUISH VIOLET\"}]},\"79\":{\"id\":\"79\",\"name\":\"Olive Green\",\"hex\":\"7C9051\",\"peeron_names\":[\"OliveGreen\"],\"ldraw_ids\":[null],\"bl_ids\":[\"155\"],\"bl_names\":[\"Olive Green\"],\"lego_colors\":[{\"lego_id\":\"330\",\"raw_name\":\"OLIVE GREEN\"}]},\"80\":{\"id\":\"80\",\"name\":\"Orange\",\"hex\":\"FF7E14\",\"peeron_names\":[\"Orange\"],\"ldraw_ids\":[\"25\"],\"bl_ids\":[\"4\"],\"bl_names\":[\"Orange\"],\"lego_colors\":[{\"lego_id\":\"106\",\"raw_name\":\"BR.ORANGE\"},{\"lego_id\":\"106\",\"raw_name\":\"BRIGHT ORANGE\"}]},\"81\":{\"id\":\"81\",\"name\":\"Red\",\"hex\":\"b30006\",\"peeron_names\":[\"Red\"],\"ldraw_ids\":[\"4\"],\"bl_ids\":[\"5\"],\"bl_names\":[\"Red\"],\"lego_colors\":[{\"lego_id\":\"21\",\"raw_name\":\"BR.RED\"},{\"lego_id\":\"21\",\"raw_name\":\"BRIGHT RED\"}]},\"82\":{\"id\":\"82\",\"name\":\"Reddish Brown\",\"hex\":\"89351d\",\"peeron_names\":[\"RedBrown\"],\"ldraw_ids\":[\"70\"],\"bl_ids\":[\"88\"],\"bl_names\":[\"Reddish Brown\"],\"lego_colors\":[{\"lego_id\":\"192\",\"raw_name\":\"RED. BROWN\"},{\"lego_id\":\"192\",\"raw_name\":\"REDDISH BROWN\"}]},\"83\":{\"id\":\"83\",\"name\":\"Rust\",\"hex\":\"b52c20\",\"peeron_names\":[\"Rust\"],\"ldraw_ids\":[\"216\"],\"bl_ids\":[\"27\"],\"bl_names\":[\"Rust\"],\"lego_colors\":[{\"lego_id\":\"216\",\"raw_name\":\"RUST\"}]},\"84\":{\"id\":\"84\",\"name\":\"Salmon\",\"hex\":\"f45c40\",\"peeron_names\":[\"Salmon\"],\"ldraw_ids\":[\"12\"],\"bl_ids\":[\"25\"],\"bl_names\":[\"Salmon\"],\"lego_colors\":[{\"lego_id\":\"4\",\"raw_name\":\"BRICK RED\"},{\"lego_id\":null,\"raw_name\":\"MEDIUM RED\"}]},\"85\":{\"id\":\"85\",\"name\":\"Sand Blue\",\"hex\":\"5a7184\",\"peeron_names\":[\"SandBlue\"],\"ldraw_ids\":[\"379\"],\"bl_ids\":[\"55\"],\"bl_names\":[\"Sand Blue\"],\"lego_colors\":[{\"lego_id\":\"135\",\"raw_name\":\"SAND BLUE\"}]},\"86\":{\"id\":\"86\",\"name\":\"Sand Purple\",\"hex\":\"B57DA5\",\"peeron_names\":[\"SandPurple\"],\"ldraw_ids\":[\"373\"],\"bl_ids\":[\"54\"],\"bl_names\":[\"Sand Purple\"],\"lego_colors\":[{\"lego_id\":\"136\",\"raw_name\":\"SAND VIOLET\"}]},\"87\":{\"id\":\"87\",\"name\":\"Sand Red\",\"hex\":\"8c6b6b\",\"peeron_names\":[\"SandRed\"],\"ldraw_ids\":[\"335\"],\"bl_ids\":[\"58\"],\"bl_names\":[\"Sand Red\"],\"lego_colors\":[{\"lego_id\":\"153\",\"raw_name\":\"SAND RED\"}]},\"88\":{\"id\":\"88\",\"name\":\"Sky Blue\",\"hex\":\"7DBFDD\",\"peeron_names\":[\"DoveBlue\"],\"ldraw_ids\":[\"232\"],\"bl_ids\":[\"87\"],\"bl_names\":[\"Sky Blue\"],\"lego_colors\":[{\"lego_id\":\"232\",\"raw_name\":\"DOVE BLUE\"}]},\"89\":{\"id\":\"89\",\"name\":\"Tan\",\"hex\":\"dec69c\",\"peeron_names\":[\"Tan\"],\"ldraw_ids\":[\"19\"],\"bl_ids\":[\"2\"],\"bl_names\":[\"Tan\"],\"lego_colors\":[{\"lego_id\":\"5\",\"raw_name\":\"BRICK YELLOW\"},{\"lego_id\":\"5\",\"raw_name\":\"BRICK-YEL\"}]},\"90\":{\"id\":\"90\",\"name\":\"Light Stone Gray\",\"hex\":\"e4e8e8\",\"peeron_names\":[\"LtStone\"],\"ldraw_ids\":[\"151\"],\"bl_ids\":[\"99\"],\"bl_names\":[\"Very Light Bluish Gray\"],\"lego_colors\":[{\"lego_id\":\"208\",\"raw_name\":\"LIGHT STONE GREY\"}]},\"91\":{\"id\":\"91\",\"name\":\"Very Light Orange\",\"hex\":\"E6C05D\",\"peeron_names\":[\"PaleOrange\"],\"ldraw_ids\":[\"68\"],\"bl_ids\":[\"96\"],\"bl_names\":[\"Very Light Orange\"],\"lego_colors\":[{\"lego_id\":\"36\",\"raw_name\":\"LIGHT YELLOWISH ORANGE\"}]},\"92\":{\"id\":\"92\",\"name\":\"White\",\"hex\":\"FFFFFF\",\"peeron_names\":[\"White\"],\"ldraw_ids\":[\"15\"],\"bl_ids\":[\"1\"],\"bl_names\":[\"White\"],\"lego_colors\":[{\"lego_id\":\"1\",\"raw_name\":\"WHITE\"}]},\"93\":{\"id\":\"93\",\"name\":\"Yellow\",\"hex\":\"f7d117\",\"peeron_names\":[\"Yellow\"],\"ldraw_ids\":[\"14\"],\"bl_ids\":[\"3\"],\"bl_names\":[\"Yellow\"],\"lego_colors\":[{\"lego_id\":\"24\",\"raw_name\":\"BR.YEL\"},{\"lego_id\":\"24\",\"raw_name\":\"BRIGHT YEL.\"},{\"lego_id\":\"24\",\"raw_name\":\"BRIGHT YELLOW\"}]},\"94\":{\"id\":\"94\",\"name\":\"Yellowish Green\",\"hex\":\"DFEEA5\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"158\"],\"bl_names\":[\"Yellowish Green\"],\"lego_colors\":[{\"lego_id\":\"326\",\"raw_name\":\"SPR. YELL. GREE\"},{\"lego_id\":\"326\",\"raw_name\":\"SPRING YELLOWISH GREEN\"}]},\"95\":{\"id\":\"95\",\"name\":\"Transparent Black\",\"hex\":\"939484\",\"peeron_names\":[\"Smoke\"],\"ldraw_ids\":[\"40\"],\"bl_ids\":[\"13\"],\"bl_names\":[\"Trans-Black\"],\"lego_colors\":[{\"lego_id\":\"111\",\"raw_name\":\"TR. BROWN\"},{\"lego_id\":\"111\",\"raw_name\":\"TR.BROWN\"}]},\"96\":{\"id\":\"96\",\"name\":\"Transparent Bright Green\",\"hex\":\"10Cb31\",\"peeron_names\":[\"TrBtGreen\"],\"ldraw_ids\":[\"35\"],\"bl_ids\":[\"108\"],\"bl_names\":[\"Trans-Bright Green\"],\"lego_colors\":[{\"lego_id\":\"311\",\"raw_name\":\"TR. BR. GREEN\"},{\"lego_id\":\"311\",\"raw_name\":\"TR. BRIGHT GREEN\"}]},\"97\":{\"id\":\"97\",\"name\":\"Transparent\",\"hex\":\"EEEEEE\",\"peeron_names\":[\"Clear\"],\"ldraw_ids\":[\"47\"],\"bl_ids\":[\"12\"],\"bl_names\":[\"Trans-Clear\"],\"lego_colors\":[{\"lego_id\":\"40\",\"raw_name\":\"TR.\"},{\"lego_id\":\"40\",\"raw_name\":\"TRANSPARENT\"}]},\"98\":{\"id\":\"98\",\"name\":\"Transparent Dark Blue\",\"hex\":\"00296B\",\"peeron_names\":[\"TrBlue\"],\"ldraw_ids\":[\"33\"],\"bl_ids\":[\"14\"],\"bl_names\":[\"Trans-Dark Blue\"],\"lego_colors\":[{\"lego_id\":\"43\",\"raw_name\":\"TR. BLUE\"},{\"lego_id\":\"43\",\"raw_name\":\"TR.BLUE\"}]},\"99\":{\"id\":\"99\",\"name\":\"Transparent Dark Pink\",\"hex\":\"CE1d9b\",\"peeron_names\":[\"TrPink\"],\"ldraw_ids\":[\"45\"],\"bl_ids\":[\"50\"],\"bl_names\":[\"Trans-Dark Pink\"],\"lego_colors\":[{\"lego_id\":\"113\",\"raw_name\":\"TR.MEDIUM REDDISH VIOLET\"},{\"lego_id\":\"113\",\"raw_name\":\"TR.ML.R.VIOL\"}]},\"100\":{\"id\":\"100\",\"name\":\"Transparent Green\",\"hex\":\"217625\",\"peeron_names\":[\"TrGreen\"],\"ldraw_ids\":[\"34\"],\"bl_ids\":[\"20\"],\"bl_names\":[\"Trans-Green\"],\"lego_colors\":[{\"lego_id\":\"48\",\"raw_name\":\"TR. GREEN\"},{\"lego_id\":\"48\",\"raw_name\":\"TR.GREEN\"}]},\"101\":{\"id\":\"101\",\"name\":\"Transparent Light Blue\",\"hex\":\"68BCC5\",\"peeron_names\":[\"TrLtBlue\"],\"ldraw_ids\":[\"41\"],\"bl_ids\":[\"15\"],\"bl_names\":[\"Trans-Light Blue\"],\"lego_colors\":[{\"lego_id\":\"42\",\"raw_name\":\"TR. LIGHT BLUE\"},{\"lego_id\":\"42\",\"raw_name\":\"TR.L.BLUE\"}]},\"102\":{\"id\":\"102\",\"name\":\"Transparent Medium Blue\",\"hex\":\"7384A5\",\"peeron_names\":[\"TrMdBlue\"],\"ldraw_ids\":[\"143\"],\"bl_ids\":[\"74\"],\"bl_names\":[\"Trans-Medium Blue\"],\"lego_colors\":[{\"lego_id\":\"143\",\"raw_name\":\"TR.FL. BLUE\"},{\"lego_id\":\"143\",\"raw_name\":\"TR.FLUORE. BLUE\"}]},\"103\":{\"id\":\"103\",\"name\":\"Transparent Neon Green\",\"hex\":\"C0F500\",\"peeron_names\":[\"TrNeonGreen\"],\"ldraw_ids\":[\"42\"],\"bl_ids\":[\"16\"],\"bl_names\":[\"Trans-Neon Green\"],\"lego_colors\":[{\"lego_id\":\"49\",\"raw_name\":\"TR. FLUORE. GREEN\"},{\"lego_id\":\"49\",\"raw_name\":\"TR.FL.GREEN\"}]},\"104\":{\"id\":\"104\",\"name\":\"Transparent Neon Yellow\",\"hex\":\"FFD700\",\"peeron_names\":[\"TrPeach\"],\"ldraw_ids\":[\"54\"],\"bl_ids\":[\"121\"],\"bl_names\":[\"Trans-Neon Yellow\"],\"lego_colors\":[{\"lego_id\":\"157\",\"raw_name\":\"TR. FLUORE.YELLOW\"}]},\"105\":{\"id\":\"105\",\"name\":\"Transparent Orange\",\"hex\":\"D78019\",\"peeron_names\":[\"TrDkOrange\"],\"ldraw_ids\":[\"182\"],\"bl_ids\":[\"98\"],\"bl_names\":[\"Trans-Orange\"],\"lego_colors\":[{\"lego_id\":\"182\",\"raw_name\":\"TR. BR. ORANGE\"},{\"lego_id\":\"182\",\"raw_name\":\"TR. BRIGHT ORANGE\"}]},\"106\":{\"id\":\"106\",\"name\":\"Transparent Pink\",\"hex\":\"FF8298\",\"peeron_names\":[\"TrLtPink\"],\"ldraw_ids\":[\"230\"],\"bl_ids\":[\"107\"],\"bl_names\":[\"Trans-Pink\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. BRIGHT PURPLE\"}]},\"107\":{\"id\":\"107\",\"name\":\"Transparent Purple\",\"hex\":\"8320B7\",\"peeron_names\":[\"TrPurple\"],\"ldraw_ids\":[\"37\"],\"bl_ids\":[\"51\"],\"bl_names\":[\"Trans-Purple\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. BRIGHT REDDISH LILAC\"},{\"lego_id\":\"126\",\"raw_name\":\"TR.BRIGHT BLUISH VIOLET\"},{\"lego_id\":\"126\",\"raw_name\":\"TR.KL.BL.VIO\"}]},\"108\":{\"id\":\"108\",\"name\":\"Transparent Red\",\"hex\":\"9C0010\",\"peeron_names\":[\"TrRed\"],\"ldraw_ids\":[\"36\"],\"bl_ids\":[\"17\"],\"bl_names\":[\"Trans-Red\"],\"lego_colors\":[{\"lego_id\":\"41\",\"raw_name\":\"TR. RED\"},{\"lego_id\":\"41\",\"raw_name\":\"TR.RED\"}]},\"109\":{\"id\":\"109\",\"name\":\"Transparent Yellow\",\"hex\":\"EBF72D\",\"peeron_names\":[\"TrYellow\"],\"ldraw_ids\":[\"46\"],\"bl_ids\":[\"19\"],\"bl_names\":[\"Trans-Yellow\"],\"lego_colors\":[{\"lego_id\":\"44\",\"raw_name\":\"TR. YELLOW\"},{\"lego_id\":\"44\",\"raw_name\":\"TR.YEL\"}]},\"110\":{\"id\":\"110\",\"name\":\"Chrome Brass\",\"hex\":\"645a4c\",\"peeron_names\":[\"ChromeBrass\"],\"ldraw_ids\":[\"60\"],\"bl_ids\":[\"57\"],\"bl_names\":[\"Chrome Antique Brass\"],\"lego_colors\":[]},\"111\":{\"id\":\"111\",\"name\":\"Chrome Black\",\"hex\":\"544E4F\",\"peeron_names\":[\"ChromeBlack\"],\"ldraw_ids\":[\"64\"],\"bl_ids\":[\"122\"],\"bl_names\":[\"Chrome Black\"],\"lego_colors\":[]},\"112\":{\"id\":\"112\",\"name\":\"Chrome Blue\",\"hex\":\"5C66A4\",\"peeron_names\":[\"ChromeBlue\"],\"ldraw_ids\":[\"61\"],\"bl_ids\":[\"52\"],\"bl_names\":[\"Chrome Blue\"],\"lego_colors\":[]},\"113\":{\"id\":\"113\",\"name\":\"Chrome Green\",\"hex\":\"3CB371\",\"peeron_names\":[\"ChromeGreen\"],\"ldraw_ids\":[\"62\"],\"bl_ids\":[\"64\"],\"bl_names\":[\"Chrome Green\"],\"lego_colors\":[]},\"114\":{\"id\":\"114\",\"name\":\"Chrome Pink\",\"hex\":\"aa4d8e\",\"peeron_names\":[\"ChromePink\"],\"ldraw_ids\":[\"63\"],\"bl_ids\":[\"82\"],\"bl_names\":[\"Chrome Pink\"],\"lego_colors\":[]},\"115\":{\"id\":\"115\",\"name\":\"Chrome Silver\",\"hex\":\"DCDCDC\",\"peeron_names\":[\"ChromeSilver\"],\"ldraw_ids\":[\"383\"],\"bl_ids\":[\"22\"],\"bl_names\":[\"Chrome Silver\"],\"lego_colors\":[]},\"116\":{\"id\":\"116\",\"name\":\"Copper\",\"hex\":\"C66921\",\"peeron_names\":[\"PearlCopper\"],\"ldraw_ids\":[\"134\"],\"bl_ids\":[\"84\"],\"bl_names\":[\"Copper\"],\"lego_colors\":[{\"lego_id\":\"139\",\"raw_name\":\"COPPER\"},{\"lego_id\":null,\"raw_name\":\"COPPER INK\"},{\"lego_id\":null,\"raw_name\":\"COPPER, DRUM LACQ\"}]},\"117\":{\"id\":\"117\",\"name\":\"Flat Silver\",\"hex\":\"8D949C\",\"peeron_names\":[\"PearlSilver\"],\"ldraw_ids\":[\"179\"],\"bl_ids\":[\"95\"],\"bl_names\":[\"Flat Silver\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"COOL SILVER\"},{\"lego_id\":\"179\",\"raw_name\":\"SILVER MET.\"},{\"lego_id\":\"179\",\"raw_name\":\"SILVER METALLIC\"}]},\"118\":{\"id\":\"118\",\"name\":\"Metallic Blue\",\"hex\":\"5686AE\",\"peeron_names\":[\"PearlBlue\"],\"ldraw_ids\":[\"137\"],\"bl_ids\":[\"78\"],\"bl_names\":[\"Metal Blue\"],\"lego_colors\":[{\"lego_id\":\"145\",\"raw_name\":\"METALLIC SAND BLUE\"}]},\"119\":{\"id\":\"119\",\"name\":\"Pearl Dark Gray\",\"hex\":\"666660\",\"peeron_names\":[\"PearlDkGray\"],\"ldraw_ids\":[\"148\"],\"bl_ids\":[\"77\"],\"bl_names\":[\"Pearl Dark Gray\"],\"lego_colors\":[{\"lego_id\":\"148\",\"raw_name\":\"METALLIC DARK GREY\"},{\"lego_id\":null,\"raw_name\":\"TITAN. METAL.\"},{\"lego_id\":null,\"raw_name\":\"TITANIUM METALLIC\"}]},\"120\":{\"id\":\"120\",\"name\":\"Pearl Gold\",\"hex\":\"e79500\",\"peeron_names\":[\"PearlGold\"],\"ldraw_ids\":[\"297\"],\"bl_ids\":[\"115\"],\"bl_names\":[\"Pearl Gold\"],\"lego_colors\":[{\"lego_id\":\"297\",\"raw_name\":\"W.GOLD\"},{\"lego_id\":\"297\",\"raw_name\":\"WARM GOLD\"}]},\"121\":{\"id\":\"121\",\"name\":\"Pearl Light Gold\",\"hex\":\"E7AE5A\",\"peeron_names\":[\"PearlLtGold\"],\"ldraw_ids\":[\"142\"],\"bl_ids\":[\"61\"],\"bl_names\":[\"Pearl Light Gold\"],\"lego_colors\":[{\"lego_id\":\"127\",\"raw_name\":\"GOLD\"}]},\"122\":{\"id\":\"122\",\"name\":\"Pearl Light Gray\",\"hex\":\"ACB7C0\",\"peeron_names\":[\"PearlLtGray\"],\"ldraw_ids\":[\"135\"],\"bl_ids\":[\"66\"],\"bl_names\":[\"Pearl Light Gray\"],\"lego_colors\":[{\"lego_id\":\"131\",\"raw_name\":\"SILVER\"}]},\"123\":{\"id\":\"123\",\"name\":\"Pearlescent\",\"hex\":\"FFFFFF\",\"peeron_names\":[\"Pearlescent\"],\"ldraw_ids\":[\"183\"],\"bl_ids\":[\"83\"],\"bl_names\":[\"Pearl White\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"METALLIC WHITE\"}]},\"124\":{\"id\":\"124\",\"name\":\"Metallic Gold\",\"hex\":\"B8860B\",\"peeron_names\":[\"MetallicGold\"],\"ldraw_ids\":[null],\"bl_ids\":[\"65\"],\"bl_names\":[\"Metallic Gold\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"GOLD INK\"},{\"lego_id\":null,\"raw_name\":\"WARM GOLD, DRUM LACQ\"}]},\"125\":{\"id\":\"125\",\"name\":\"Metallic Green\",\"hex\":\"bdb573\",\"peeron_names\":[\"MetallicGreen\"],\"ldraw_ids\":[null],\"bl_ids\":[\"70\"],\"bl_names\":[\"Metallic Green\"],\"lego_colors\":[{\"lego_id\":\"200\",\"raw_name\":\"LEMON METALLIC\"}]},\"126\":{\"id\":\"126\",\"name\":\"Metallic Silver\",\"hex\":\"C0C0C0\",\"peeron_names\":[\"MetallicSilver\"],\"ldraw_ids\":[null],\"bl_ids\":[\"67\"],\"bl_names\":[\"Metallic Silver\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"COOL SILVER, DRUM LACQ\"},{\"lego_id\":null,\"raw_name\":\"SILVER INK\"}]},\"127\":{\"id\":\"127\",\"name\":\"Glow in the Dark Opaque\",\"hex\":\"d4d5c9\",\"peeron_names\":[\"GlowInTheDark\"],\"ldraw_ids\":[\"21\"],\"bl_ids\":[\"46\"],\"bl_names\":[\"Glow In Dark Opaque\"],\"lego_colors\":[{\"lego_id\":\"50\",\"raw_name\":\"PHOSPHORESCENT WHITE\"}]},\"128\":{\"id\":\"128\",\"name\":\"Glow in the Dark Transparent\",\"hex\":\"bdc6ad\",\"peeron_names\":[\"TrGlowInTheDark\"],\"ldraw_ids\":[\"294\"],\"bl_ids\":[\"118\"],\"bl_names\":[\"Glow In Dark Trans\"],\"lego_colors\":[{\"lego_id\":\"294\",\"raw_name\":\"PHOSPH.GREEN\"}]},\"129\":{\"id\":\"129\",\"name\":\"Glow in the Dark White\",\"hex\":\"d9d9d9\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"159\"],\"bl_names\":[\"Glow in Dark White\"],\"lego_colors\":[{\"lego_id\":\"329\",\"raw_name\":\"WHITE GLOW\"}]},\"130\":{\"id\":\"130\",\"name\":\"Translucent White\",\"hex\":\"d4d3dd\",\"peeron_names\":[\"TrLuWhite\"],\"ldraw_ids\":[\"79\"],\"bl_ids\":[\"60\"],\"bl_names\":[\"Milky White\"],\"lego_colors\":[{\"lego_id\":\"20\",\"raw_name\":\"NATURE\"}]},\"131\":{\"id\":\"131\",\"name\":\"Transparent Glitter\",\"hex\":\"b2adaa\",\"peeron_names\":[\"ClearGlitter\"],\"ldraw_ids\":[\"117\"],\"bl_ids\":[\"101\"],\"bl_names\":[\"Glitter Trans-Clear\"],\"lego_colors\":[{\"lego_id\":\"117\",\"raw_name\":\"TR.W.GLITTER\"},{\"lego_id\":\"117\",\"raw_name\":\"TRANSPARENT W. GLITTER 2%\"}]},\"132\":{\"id\":\"132\",\"name\":\"Transparent Pink Glitter\",\"hex\":\"ab43c3\",\"peeron_names\":[\"TrPinkGlitter\"],\"ldraw_ids\":[\"114\"],\"bl_ids\":[\"100\"],\"bl_names\":[\"Glitter Trans-Dark Pink\"],\"lego_colors\":[{\"lego_id\":\"114\",\"raw_name\":\"TR. M. REDDISH-VIOL W. GLIT.2%\"}]},\"133\":{\"id\":\"133\",\"name\":\"Speckle Black Copper\",\"hex\":\"5F4E47\",\"peeron_names\":[\"BlackCopperGlitter\"],\"ldraw_ids\":[\"75\"],\"bl_ids\":[\"116\"],\"bl_names\":[\"Speckle Black-Copper\"],\"lego_colors\":[]},\"134\":{\"id\":\"134\",\"name\":\"Speckle Gray\",\"hex\":\"4A6363\",\"peeron_names\":[\"DkStoneGlitter\"],\"ldraw_ids\":[\"76\"],\"bl_ids\":[\"117\"],\"bl_names\":[\"Speckle DBGray-Silver\"],\"lego_colors\":[]},\"135\":{\"id\":\"135\",\"name\":\"Modulex Aqua Green\",\"hex\":\"27867E\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"142\"],\"bl_names\":[\"Mx Aqua Green\"],\"lego_colors\":[]},\"136\":{\"id\":\"136\",\"name\":\"Modulex Black\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"128\"],\"bl_names\":[\"Mx Black\"],\"lego_colors\":[]},\"137\":{\"id\":\"137\",\"name\":\"Modulex Brown\",\"hex\":\"907450\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"132\"],\"bl_names\":[\"Mx Brown\"],\"lego_colors\":[]},\"138\":{\"id\":\"138\",\"name\":\"Modulex Buff\",\"hex\":\"DEC69C\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"133\"],\"bl_names\":[\"Mx Buff\"],\"lego_colors\":[]},\"139\":{\"id\":\"139\",\"name\":\"Modulex Clear\",\"hex\":\"FFFFFF\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"149\"],\"bl_names\":[\"Mx Clear\"],\"lego_colors\":[]},\"140\":{\"id\":\"140\",\"name\":\"Modulex Lemon\",\"hex\":\"BDC618\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"139\"],\"bl_names\":[\"Mx Lemon\"],\"lego_colors\":[]},\"141\":{\"id\":\"141\",\"name\":\"Modulex Light Gray\",\"hex\":\"9C9C9C\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"125\"],\"bl_names\":[\"Mx Light Gray\"],\"lego_colors\":[]},\"142\":{\"id\":\"142\",\"name\":\"Modulex Light Orange\",\"hex\":\"F7AD63\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"136\"],\"bl_names\":[\"Mx Light Orange\"],\"lego_colors\":[]},\"143\":{\"id\":\"143\",\"name\":\"Modulex Light Yellow\",\"hex\":\"FFE371\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"137\"],\"bl_names\":[\"Mx Light Yellow\"],\"lego_colors\":[]},\"144\":{\"id\":\"144\",\"name\":\"Modulex Medium Blue\",\"hex\":\"61AFFF\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"144\"],\"bl_names\":[\"Mx Medium Blue\"],\"lego_colors\":[]},\"145\":{\"id\":\"145\",\"name\":\"Modulex Pastel Blue\",\"hex\":\"68AECE\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"145\"],\"bl_names\":[\"Mx Pastel Blue\"],\"lego_colors\":[]},\"146\":{\"id\":\"146\",\"name\":\"Modulex Pink\",\"hex\":\"F785B1\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"148\"],\"bl_names\":[\"Mx Pink\"],\"lego_colors\":[]},\"147\":{\"id\":\"147\",\"name\":\"Modulex Pink Red\",\"hex\":\"F45C40\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"130\"],\"bl_names\":[\"Mx Pink Red\"],\"lego_colors\":[]},\"148\":{\"id\":\"148\",\"name\":\"Modulex Red\",\"hex\":\"B52C20\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"129\"],\"bl_names\":[\"Mx Red\"],\"lego_colors\":[]},\"149\":{\"id\":\"149\",\"name\":\"Modulex Teal Blue\",\"hex\":\"467083\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"146\"],\"bl_names\":[\"Mx Teal Blue\"],\"lego_colors\":[]},\"150\":{\"id\":\"150\",\"name\":\"Modulex Terracotta\",\"hex\":\"5C5030\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"134\"],\"bl_names\":[\"Mx Terracotta\"],\"lego_colors\":[]},\"151\":{\"id\":\"151\",\"name\":\"Modulex Tile Brown\",\"hex\":\"330000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"131\"],\"bl_names\":[\"Mx Tile Brown\"],\"lego_colors\":[]},\"152\":{\"id\":\"152\",\"name\":\"Modulex Tile Gray\",\"hex\":\"6B5A5A\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"127\"],\"bl_names\":[\"Mx Tile Gray\"],\"lego_colors\":[]},\"153\":{\"id\":\"153\",\"name\":\"Modulex Violet\",\"hex\":\"BD7D85\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"147\"],\"bl_names\":[\"Mx Violet\"],\"lego_colors\":[]},\"154\":{\"id\":\"154\",\"name\":\"Modulex White\",\"hex\":\"FFFFFF\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"123\"],\"bl_names\":[\"Mx White\"],\"lego_colors\":[]},\"156\":{\"id\":\"156\",\"name\":\"Warm Yellowish Orange\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"-5\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"WARM YELLOWISH ORANGE\"}]},\"157\":{\"id\":\"157\",\"name\":\"Medium Yellowish Orange\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"-6\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"MEDIUM YELLOWISH ORANGE\"}]},\"158\":{\"id\":\"158\",\"name\":\"Reddish Orange\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"-7\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"BRIGHT REDDISH ORANGE\"}]},\"160\":{\"id\":\"160\",\"name\":\"Dark Nougat\",\"hex\":\"000000\",\"peeron_names\":[\"DkNougat\"],\"ldraw_ids\":[null],\"bl_ids\":[\"-8\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":\"128\",\"raw_name\":\"DARK NOUGAT\"}]},\"161\":{\"id\":\"161\",\"name\":\"Transparent Neon Reddish Orange\",\"hex\":\"FF4231\",\"peeron_names\":[\"TrNeonOrange\"],\"ldraw_ids\":[\"57\"],\"bl_ids\":[\"18\"],\"bl_names\":[\"Trans-Neon Orange\"],\"lego_colors\":[{\"lego_id\":\"47\",\"raw_name\":\"TR. FLUORE.REDD. ORANGE\"},{\"lego_id\":\"47\",\"raw_name\":\"TR.FL.REDORA\"}]},\"162\":{\"id\":\"162\",\"name\":\"Transparent Fire Yellow\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"-9\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. FIRE YELLOW\"}]},\"163\":{\"id\":\"163\",\"name\":\"Transparent Light Royal Blue\",\"hex\":\"000000\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"-10\"],\"bl_names\":[null],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR. LIGHT ROYAL BLUE\"}]},\"165\":{\"id\":\"165\",\"name\":\"Transparent Light Blue Glitter\",\"hex\":\"68BCC5\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"162\"],\"bl_names\":[\"Glitter Trans-Light Blue\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"PCTR LI.BLUE W\\/\"}]},\"167\":{\"id\":\"167\",\"name\":\"Transparent Neon Green Glitter\",\"hex\":\"C0F500\",\"peeron_names\":[null],\"ldraw_ids\":[null],\"bl_ids\":[\"163\"],\"bl_names\":[\"Glitter Trans-Neon Green\"],\"lego_colors\":[{\"lego_id\":null,\"raw_name\":\"TR.FL.GRE W\\/GLI\"}]},\"169\":{\"id\":\"169\",\"name\":\"Curry\",\"hex\":\"D7A94B\",\"peeron_names\":[\"Curry\"],\"ldraw_ids\":[null],\"bl_ids\":[\"161\"],\"bl_names\":[\"Dark Yellow\"],\"lego_colors\":[{\"lego_id\":\"180\",\"raw_name\":\"CURRY\"}]}}";

  boColorTable colortable;

  boReadColorTable( &colortable, bar, 0 );

  printf( "\n\n" );
  printf( "#define BS_COLOR_INDEX_RANGE (%d)\n", BO_COLOR_TABLE_RANGE );
  printf( "\n" );
  printf( "int bsColorTranslationBo2Bl[BS_COLOR_INDEX_RANGE] = {" );
  for( index = 0 ; index < BO_COLOR_TABLE_RANGE ; index++ )
  {
    printf( "%d", colortable.bo2bl[index] );
    if( index != (BO_COLOR_TABLE_RANGE-1) )
      printf( ", " );
  }
  printf( "};\n\n" );
  printf( "int bsColorTranslationBl2Bo[BS_COLOR_INDEX_RANGE] = {" );
  for( index = 0 ; index < BO_COLOR_TABLE_RANGE ; index++ )
  {
    printf( "%d", colortable.bl2bo[index] );
    if( index != (BO_COLOR_TABLE_RANGE-1) )
      printf( ", " );
  }
  printf( "};\n\n" );

  return 1;
}

#endif


////


#if 0

#include <string.h>
#include <math.h>
#include <limits.h>
#include <float.h>

#include <stdarg.h>


int main()
{
  int index;
  printf( "Color Table\n" );
  printf( "\n" );
  for( index = 0 ; index < BS_COLOR_INDEX_RANGE ; index++ )
    printf( "BrickLink %d : BrickOwl  %d\n", index, bsColorTranslationBl2Bo[index] );
  printf( "\n" );
  for( index = 0 ; index < BS_COLOR_INDEX_RANGE ; index++ )
    printf( "BrickOwl  %d : BrickLink %d\n", index, bsColorTranslationBo2Bl[index] );
  printf( "\n" );
  return 1;
}

#endif


////

